
!UiViewSingleSelection methodsFor: 'add/remove' stamp: 'mt 10/11/2010 09:21:51.677'!
add: aCellIndex event: aUserInputEvent

	selectedCell := aCellIndex.
	self selectionChanged.! !

!UiViewSingleSelection methodsFor: 'accessing' stamp: 'mt 10/11/2010 14:35:26.499'!
cells

	^ selectedCell
		ifNil: [#()]
		ifNotNil: [{selectedCell}]! !

!UiViewSingleSelection methodsFor: 'add/remove' stamp: 'mt 10/11/2010 17:57:25.989'!
clear

	selectedCell := nil.
	self selectionChanged.! !

!UiViewSingleSelection methodsFor: 'accessing' stamp: 'mt 10/16/2010 08:16:06.717'!
currentCell

	^ selectedCell! !

!UiViewSingleSelection methodsFor: 'accessing' stamp: 'mt 10/16/2010 14:26:19.682'!
currentCell: aPoint

	selectedCell := aPoint.
	self currentCellChanged.! !

Morph subclass: #UiItemViewport
	instanceVariableNames: 'rows columns hoveredCell selectionColor selection selectionMode selectionBehavior verticalHeader horizontalHeader rowOrder columnOrder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiItemViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/16/2010 19:58:48.094'!
cellBoundsFor: aCellIndex

	| col row |
	(aCellIndex x > columns size
		or: [aCellIndex y > rows size])
		ifTrue: [^ 0@0 extent: 0@0].
	
	col := self columnAt: aCellIndex x.
	row := self rowAt: aCellIndex y.
	
	^ (self leftForColumn: col) @ (self topForRow: row)
		extent: col width @ row height! !

!UiItemViewport methodsFor: 'rows/columns - to cell' stamp: 'mt 10/17/2010 09:47:23.765'!
cellIndexFromPoint: aPoint
	"Given a point in pixel coordinates."
	
	| offset cellIndex |
	offset := self topLeft.
	cellIndex := 0@0.
	self columnsDo: [:colInfo |
		cellIndex := cellIndex + (1@0).
		self rowsDo: [:rowInfo |
			cellIndex := cellIndex + (0@1).
			((offset extent: colInfo width @ rowInfo height) containsPoint: aPoint)
				ifTrue: [^ cellIndex].
			offset := offset translateBy: 0 @ rowInfo height].
		offset := (offset x + colInfo width) @ self top.
		cellIndex := cellIndex x @ 0].
	
	^ nil! !

!UiItemViewport methodsFor: 'initialization' stamp: 'mt 10/16/2010 08:26:15.478'!
clear

	self selection clear.
	
	columns do: [:colInfo | colInfo clear].
	rows removeAll.
	self removeAllMorphs.! !

!UiItemViewport methodsFor: 'rows/columns - to info' stamp: 'mt 10/16/2010 19:56:38.765'!
columnAt: index

	index > columns size
		ifTrue: [index - columns size timesRepeat: [columns add: UiViewColumnInfo new]].
	
	^ self columnOrder items: columns at: index! !

!UiItemViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/16/2010 19:58:57.129'!
columnBoundsFor: aColIndex

	| col |
	aColIndex > columns size
		ifTrue: [^ 0@0 extent: 0@0].
		
	col := self columnAt: aColIndex.
	
	^ (self leftForColumn: col) @ self top
		extent: col width @ self height! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/16/2010 15:00:57.992'!
columnOrder

	^ columnOrder! !

!UiItemViewport methodsFor: 'enumerating - ordered' stamp: 'mt 10/17/2010 08:20:05.896'!
columnsDo: aBlock

	self columnOrder items: columns do: aBlock.! !

!UiItemViewport methodsFor: 'enumerating - ordered' stamp: 'mt 10/17/2010 08:20:10.134'!
columnsWithIndexDo: aBlock

	self columnOrder items: columns withIndexDo: aBlock.! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 10/16/2010 14:30:59.752'!
drawCurrentCellOn: aCanvas

	self selection currentCell ifNil: [^ self].
	
	self selectionBehavior = #selectCells ifTrue: [
		self
			drawHighlightOn: aCanvas
			bounds: (self cellBoundsFor: self selection currentCell)
			color: self selectionColor darker.
		^ self].
		
	self selectionBehavior = #selectRows ifTrue: [
		self
			drawHighlightOn: aCanvas
			bounds: (self rowBoundsFor: self selection currentCell y)
			color: self selectionColor darker.
		^ self].
	
	self selectionBehavior = #selectColumns ifTrue: [
		self
			drawHighlightOn: aCanvas
			bounds: (self columnBoundsFor: self selection currentCell x)
			color: self selectionColor darker.
		^ self]! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 10/16/2010 20:02:30.608'!
drawSubmorphsOn: aCanvas 
	"Clip in cells. Optimized."
	
	| offset |
	submorphs isEmpty ifTrue: [^self].
	
	offset := self topLeft.
	self columnsWithIndexDo: [:colInfo :colIndex |
		
		self rowOrder items: colInfo items withIndexDo: [:item :rowIndex | | rowInfo |
			rowInfo := rows at: rowIndex.
			aCanvas
				clipBy: (offset extent: colInfo width @ rowInfo height)
				during: [:canvas | canvas fullDrawMorph: item].
			
			offset := offset translateBy: 0 @ rowInfo height].
		
		offset := (offset x + colInfo width) @ self top].! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/16/2010 08:01:57.895'!
indent
	"Defines how much items of the first column will be moved to the left for each level - including the first one."
	
	^ 0! !

!UiItemViewport methodsFor: 'initialization' stamp: 'mt 10/17/2010 10:10:14.259'!
initialize

	super initialize.
	self color: Color transparent.
		
	rows := OrderedCollection new.
	columns := OrderedCollection new.
	
	rowOrder := UiItemOrder new sortBlock: [:i1 :i2 |
		(i1 valueOfProperty: #text) asString <= (i2 valueOfProperty: #text) asString].
	columnOrder := UiItemOrder new.
	
	self selectionMode: UiViewSingleSelection.! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 10/16/2010 08:21:21.035'!
keyStroke: evt

	| cc |
	cc := self selection currentCell.

	"Manuall navigation."
	cc ifNil: [^ self selection add: 1@1 event: evt].

	evt keyCharacter = Character arrowUp
		ifTrue: [self selection add: (cc - (0@1) max: 1@1) event: evt].
		
	evt keyCharacter = Character arrowDown
		ifTrue: [self selection add: (cc + (0@1) min: (columns size @ rows size) max: 1@1) event: evt].
		
	evt keyCharacter = Character arrowLeft
		ifTrue: [self selection add: (cc - (1@0) max: 1@1) event: evt].
		
	evt keyCharacter = Character arrowRight
		ifTrue: [self selection add: (cc + (1@0) min: (columns size @ rows size) max: 1@1) event: evt].! !

!UiItemViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/16/2010 19:59:37.763'!
leftForColumn: aColumnInfo

	| result |
	result := self left.
	self columnsDo: [:col |
		col = aColumnInfo ifTrue: [^ result].
		result := result + col width].
	
	Error signal: 'Column info not found!!'.! !

!UiItemViewport methodsFor: 'rows/columns - to model index' stamp: 'mt 10/17/2010 09:23:15.593'!
modelIndexFor: aCellIndex

	aCellIndex ifNil: [^ nil].

	^ (self rowOrder items: (self columnAt: aCellIndex x) items at: aCellIndex y)
		valueOfProperty: #modelIndex! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 10/16/2010 14:29:26.513'!
mouseDown: evt

	self selection
		add: (self cellIndexFromPoint: evt position)
		event: evt.
		
	evt hand
		waitForClicksOrDrag: self
		event: evt
		selectors: {#click:. #doubleClick:. nil. #startDrag:}
		threshold: 1. ! !

!UiItemViewport methodsFor: 'rows/columns - to info' stamp: 'mt 10/16/2010 19:56:47.691'!
rowAt: index

	^ self rowOrder items: rows at: index! !

!UiItemViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/16/2010 19:59:07.12'!
rowBoundsFor: aRowIndex

	| row |
	aRowIndex > rows size
		ifTrue: [^ 0@0 extent: 0@0].
		
	row := self rowAt: aRowIndex.
	
	^ self left @ (self topForRow: row)
		extent: self width @ row height! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/16/2010 15:00:50.256'!
rowOrder

	^ rowOrder! !

!UiItemViewport methodsFor: 'enumerating - ordered' stamp: 'mt 10/16/2010 19:06:41.893'!
rowsDo: aBlock

	self rowOrder items: rows do: aBlock.! !

!UiItemViewport methodsFor: 'enumerating - ordered' stamp: 'mt 10/16/2010 19:49:38.102'!
rowsWithIndexDo: aBlock

	self rowOrder items: rows withIndexDo: aBlock.! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/16/2010 14:27:29.244'!
selection: aSelection

	selection := aSelection.
	self connect: aSelection signal: #selectionChanged toSelector: #redrawLater.
	self connect: aSelection signal: #selectionChanged toSelector: #updateFocus.
	self connect: aSelection signal: #currentCellChanged toSelector: #redrawLater.
	
	self redrawLater.! !

!UiItemViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/16/2010 19:59:22.557'!
topForRow: aRowInfo

	| result |
	result := self top.
	self rowsDo: [:row |
		row = aRowInfo ifTrue: [^ result].
		result := result + row height].
	
	Error signal: 'Row info not found!!'.! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/16/2010 19:47:10.47'!
updateColumnsLayout

	| offset |
	self columnsDo: [:colInfo |
		offset := 0.
		self rowOrder items: colInfo items withIndexDo: [:item :rowIndex |
			| height |
			height := (rows at: rowIndex) height.
			colInfo vAlignment = #top
				ifTrue: [item top: offset].
			colInfo vAlignment = #center
				ifTrue: [item top: offset + (height - item height // 2)].
			colInfo vAlignment = #bottom
				ifTrue: [item bottom: offset + height].
							
			offset := offset + height]].! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/16/2010 18:00:37.584'!
updateFirstColumnIndent

	columns first items do: [:item |
		item left: item left + (item valueOfProperty: #indent)].! !

!UiItemViewport methodsFor: 'updating' stamp: 'mt 10/16/2010 08:23:31.568'!
updateFocus
	"The important part is always the current cell."
	
	self selection currentCell ifNotNil: [:cc |
		self focusChanged: (self cellBoundsFor: cc)].! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/16/2010 19:45:11.53'!
updateHeaderLayout
	"Relayout changed header items."
	
	self horizontalHeader ifNotNil: [:hh |
		hh removeAllMorphs.
		self columnsDo: [:colInfo | hh addMorphBack: colInfo headerItem]].
	self verticalHeader ifNotNil: [:vh |
		vh removeAllMorphs.
		self rowsDo: [:rowInfo | vh addMorphBack: rowInfo headerItem]].! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/16/2010 19:47:21.042'!
updateItemOrder

	"Sort after first column for now."
	self rowOrder updateWith: columns first items.! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/16/2010 18:03:45.47'!
updateLayout

	columns ifEmpty: [^ self].
	
	self
		updateSizesOfRowsAndColumns;
		updateItemOrder;
		updateColumnsLayout;
		updateRowsLayout;
		updateFirstColumnIndent;
		updateHeaderLayout;
		updateExtent.! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/16/2010 19:44:44.663'!
updateRowsLayout

	| offset |
	self rowsDo: [:rowInfo |
		offset := 0.
		self columnOrder items: rowInfo items withIndexDo: [:item :colIndex |
			| width hAlignment |
			width := (columns at: colIndex) width.
			hAlignment := (columns at: colIndex) hAlignment.
			hAlignment = #left
				ifTrue: [item left: offset].
			hAlignment = #center
				ifTrue: [item left: offset + (width - item width // 2)].
			hAlignment = #right
				ifTrue: [item right: offset + width].
			
			offset := offset + width]].! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/16/2010 08:11:00.988'!
updateSizesOfRowsAndColumns

	columns do: [:column | column updateSize].
	rows do: [:row | row updateSize].! !

!UiViewSelection methodsFor: 'add/remove' stamp: 'mt 10/11/2010 09:07:25.205'!
add: aCellIndex event: aUserInputEvent! !

!UiViewSelection methodsFor: 'accessing' stamp: 'mt 10/11/2010 09:13:15.101'!
cells
	"Return an array with all selected cells."
	
	self subclassResponsibility.! !

!UiViewSelection methodsFor: 'add/remove' stamp: 'mt 10/11/2010 17:57:02.818'!
clear
! !

!UiViewSelection methodsFor: 'accessing' stamp: 'mt 10/16/2010 08:15:39.961'!
currentCell
	"Return the current cell. Normally the last added one."

	self subclassResponsibility.! !

!UiViewSelection methodsFor: 'accessing' stamp: 'mt 10/16/2010 14:23:46.96'!
currentCell: aPoint

	self subclassResponsibility.! !

!UiViewSelection methodsFor: 'signals' stamp: 'mt 10/16/2010 14:26:07.47'!
currentCellChanged

	self emit.! !

Object subclass: #UiItemOrder
	instanceVariableNames: 'map sortBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiItemOrder commentStamp: 'mt 10/16/2010 14:45:30.134' prior: 0!
A cached order of some items. Needs to be updated frequently.!

!UiItemOrder methodsFor: 'accessing' stamp: 'mt 10/16/2010 19:08:23.107'!
items: someItems at: anIndex
	
	self map ifNil: [^ someItems at: anIndex].
	^ someItems at: (self map at: anIndex)! !

!UiItemOrder methodsFor: 'enumerating' stamp: 'mt 10/16/2010 15:03:57.143'!
items: someItems collect: aBlock

	self map ifNil: [^ someItems collect: aBlock].
	^ map collect: [:index | aBlock value: (someItems at: index)]! !

!UiItemOrder methodsFor: 'enumerating' stamp: 'mt 10/16/2010 15:03:42.612'!
items: someItems do: aBlock

	self map ifNil: [^ someItems do: aBlock].
	map do: [:index | aBlock value: (someItems at: index)]! !

!UiItemOrder methodsFor: 'enumerating' stamp: 'mt 10/16/2010 19:12:41.82'!
items: someItems withIndexDo: aBlock

	self map ifNil: [^ someItems withIndexDo: aBlock].
	map do: [:index | aBlock value: (someItems at: index) value: index]! !

!UiItemOrder methodsFor: 'accessing' stamp: 'mt 10/16/2010 14:57:00.465'!
map

	^ map! !

!UiItemOrder methodsFor: 'accessing' stamp: 'mt 10/16/2010 14:57:44.975'!
map: anArray
	"Example: #(5 4 3 2 1) will revert a list with 5 items."

	map := anArray.! !

!UiItemOrder methodsFor: 'manual mapping' stamp: 'mt 10/16/2010 20:11:53.792'!
mapIndex: anIndex

	self map ifNil: [^ anIndex].
	^ self map at: anIndex! !

!UiItemOrder methodsFor: 'accessing' stamp: 'mt 10/16/2010 15:04:46.949'!
sortBlock

	^ sortBlock! !

!UiItemOrder methodsFor: 'accessing' stamp: 'mt 10/16/2010 14:44:45.717'!
sortBlock: aBlock

	sortBlock := aBlock.! !

!UiItemOrder methodsFor: 'manual mapping' stamp: 'mt 10/16/2010 20:12:05.571'!
unmapIndex: anIndex

	self map ifNil: [^ anIndex].
	^ self map indexOf: anIndex! !

!UiItemOrder methodsFor: 'updating' stamp: 'mt 10/16/2010 15:05:08.919'!
updateWith: someItems

	| sortedCopy |
	self sortBlock ifNil: [^ self map: nil].	
	
	sortedCopy := someItems copy sortBy: self sortBlock.
	map := Array new: someItems size.
	sortedCopy withIndexDo: [:item :index |
		map at: index put: (someItems indexOf: item)].! !

UiItemOrder subclass: #UiTreeItemOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiTreeItemOrder methodsFor: 'updating' stamp: 'mt 10/16/2010 18:57:52.003'!
parent: currentParent list: aList result: result

	aList do: [:each |
		| index |
		index := each valueOfProperty: #modelIndex.
		index parent = currentParent ifTrue: [
			result add: each.
			self parent: index list: (aList copyWithout: each) result: result]].! !

!UiTreeItemOrder methodsFor: 'updating' stamp: 'mt 10/16/2010 18:59:59.151'!
rebuildTreeStructure: items

	| result |
	result := OrderedCollection new.
	self parent: nil list: items result: result.
	^ result! !

!UiTreeItemOrder methodsFor: 'updating' stamp: 'mt 10/16/2010 19:00:21.046'!
updateWith: someItems

	| sortedCopy |
	self sortBlock ifNil: [^ self map: nil].	
	
	sortedCopy := someItems copy sortBy: self sortBlock.
	sortedCopy := self rebuildTreeStructure: sortedCopy.
	
	map := Array new: someItems size.
	sortedCopy withIndexDo: [:item :index |
		map at: index put: (someItems indexOf: item)].! !

!UiIconPickerDialog methodsFor: 'as yet unclassified' stamp: 'mt 10/17/2010 10:09:58.568'!
initialize

	super initialize.
	
	iconSetCombo := UiComboBox new hResizing: #spaceFill.
	UiIcons subclassesDo: [:s | iconSetCombo addText: s name].
	self connect: iconSetCombo signal: #currentIndexChanged:text: toSelector: #changeIconSet:.
	
	iconView := UiListIconView new
		listOrientation: #vertical;
		model: (UiIconModel new showText: false);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderStyle: (BorderStyle inset width: 1).
	self connect: iconView signal: #clicked: toSelector: #chooseIcon:.
	
	self
		color: (Color gray: 0.9);
		changeTableLayout;
		listDirection: #topToBottom;
		layoutInset: 5;
		cellInset: 5;
		cellPositioning: #topLeft.
		
	self
		addMorphBack: (UiLabel new text: 'Select an icon set then pick an icon below. The code to get
the form will be copied into the <b>clipboard</b>.' asHtmlText);
		addMorphBack: iconSetCombo;
		addMorphBack: iconView.
		
	"Initial set."
	self changeIconSet: iconSetCombo currentIndex.! !

!UiTreeViewport methodsFor: 'event handling' stamp: 'mt 10/17/2010 09:58:48.421'!
click: evt

	| cell item |
	cell := self cellIndexFromPoint: evt position.
	cell ifNil: [^ self].
	
	item := (self rowAt: cell y) items at: 1.

	"Recognize a click on the decoration."
	(evt position x < item left
		and: [evt position x >= (item left - self indent)])
		ifTrue: [self decorationClicked: (item valueOfProperty: #modelIndex)].! !

!UiTreeViewport methodsFor: 'drawing' stamp: 'mt 10/17/2010 09:54:46.812'!
drawTreeStructureOn: aCanvas
	
	| first last |
	columns ifEmpty: [^ self].
	
	(self leftForColumn: columns first) < aCanvas clipRect left
		ifTrue: [^ self].
	
	first := self cellIndexFromPoint: (self bounds pointNearestTo: aCanvas clipRect topLeft).
	last := self cellIndexFromPoint: (self bounds pointNearestTo: aCanvas clipRect bottomLeft).

	first ifNil: [first := 1@1].
	last ifNil: [last := 1@rows size].
	
	last < first ifTrue: [^ self].

	first y to: last y do: [:rowIndex |
		| colIndex item cellBounds form |
		colIndex := self columnOrder unmapIndex: 1.
		cellBounds := self cellBoundsFor: colIndex@rowIndex.
		item := self columnOrder items: (self rowAt: rowIndex) items at: colIndex.
		form := UiSilkIcons bulletArrowDownIcon.
		form := (item valueOfProperty: #hasChildren)
			ifFalse: [nil]
			ifTrue: [(item valueOfProperty: #isExpanded)
				ifFalse: [form rotateBy: #left centerAt: 8@8]
				ifTrue: [form]].

		form ifNotNil: [
			aCanvas
				translucentImage: form
				at: (cellBounds left + ((item valueOfProperty: #indent) - self indent))
					@ (cellBounds top + (cellBounds height - form height // 2))]].! !

!UiTreeViewport methodsFor: 'initialization' stamp: 'mt 10/17/2010 10:10:27.174'!
initialize

	super initialize.
	
	rowOrder := UiTreeItemOrder new sortBlock: [:i1 :i2 |
		(i1 valueOfProperty: #text) asString <= (i2 valueOfProperty: #text) asString].
	
	self selectionBehavior: #selectRows.! !

!UiListIconViewport methodsFor: 'rows/columns - to cell' stamp: 'mt 10/17/2010 10:14:26.148'!
cellIndexFromPoint: aPoint
	"Given a point in pixel coordinates."
	
	| cell |
	self orientation = #default ifTrue: [
		| offset cellIndex |
		offset := self topLeft.
		cellIndex := 1@0.
		self rowsDo: [:rowInfo | 
			cellIndex := cellIndex + (0@1).
			((offset extent: self width @ rowInfo height) containsPoint: aPoint)
				ifTrue: [^ cellIndex].
			offset := offset translateBy: 0 @ rowInfo height].
	
		^ nil].
	
	cell := ((aPoint - self topLeft) // (maxItemExtent)) + (1@1).
	
	self orientation = #vertical
		ifTrue: [
			(cell x > self maxItemsPerLine
				or: [cell y - 1 * self maxItemsPerLine + cell x > rows size])
				ifTrue: [^ nil]]
		ifFalse: [
			(cell y > self maxItemsPerLine
				or: [cell x - 1 * self maxItemsPerLine + cell y > rows size])
				ifTrue: [^ nil]].
	
	^ cell! !

!UiListIconViewport methodsFor: 'rows/columns - to model index' stamp: 'mt 10/17/2010 10:01:36.664'!
modelIndexFor: aCellIndex

	self orientation = #default
		ifTrue: [^ super modelIndexFor: aCellIndex].

	aCellIndex ifNil: [^ nil].
	
	^ (self orientation = #vertical
		ifTrue: [self rowAt: aCellIndex y - 1 * self maxItemsPerLine + aCellIndex x]
		ifFalse: [self rowAt: aCellIndex x - 1 * self maxItemsPerLine + aCellIndex y]) firstModelIndex! !

!UiListIconViewport methodsFor: 'layouting' stamp: 'mt 10/17/2010 10:03:25.756'!
updateLayout

	"There is no list wrapping in #default layout. Just use the super implementation."
	self orientation = #default
		ifTrue: [^ super updateLayout].	
	
	columns ifEmpty: [^ self].
	
	self
		updateItemOrder;
		updateMaxItemExtent;
		updateSingleColumnLayout;
		updateExtent.! !

!UiListIconViewport methodsFor: 'layouting' stamp: 'mt 10/16/2010 18:06:54.189'!
updateMaxItemExtent

	maxItemExtent := 1@1.
	columns first items do: [:item | maxItemExtent := maxItemExtent max: item extent].! !

!UiListIconViewport methodsFor: 'layouting' stamp: 'mt 10/17/2010 10:03:58.353'!
updateSingleColumnLayout

	| offset hAlignment |
	offset := self topLeft.
	hAlignment := columns first hAlignment.

	self rowOrder items: columns first items do: [:item |		
		hAlignment = #left
			ifTrue: [item topLeft: offset].
		hAlignment = #center
			ifTrue: [item topLeft: offset + ((maxItemExtent x - item width)//2 @0)].
		hAlignment = #right
			ifTrue: [item topRight: offset + (maxItemExtent x @ 0)].

		self orientation = #vertical
			ifTrue: [
				offset := offset + (maxItemExtent x @ 0).
				(offset x + maxItemExtent x)  > (self owner width - 5)
					ifTrue: [offset := self left @ (offset y + maxItemExtent y)]]
			ifFalse: [
				offset := offset + (0 @ maxItemExtent y).
				(offset y + maxItemExtent y)  > (self owner height - 5)
					ifTrue: [offset := (offset x + maxItemExtent x) @ self top]]].! !

Point subclass: #UiModelIndex
	instanceVariableNames: 'parent model properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiModelIndex commentStamp: 'mt 10/16/2010 08:08:55.091' prior: 0!
Abstract class that represents a wrapper around some data item from a model in a view, i.e., tree view, table view, list view. Concrete implementations need to define which messages will be understood by the model in order to get the data.

No data caching intended here. But may store useful properties in order to be able to navigate quickly in the model whenever confronted with that model index again, e.g. "Please, model, tell be all your child indices based on this parent index."

A model generates all model indices.!

UiModelIndex subclass: #UiPluggableModelIndex
	instanceVariableNames: 'textSelector iconSelector hasChildrenSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiPluggableModelIndex commentStamp: 'mt 10/16/2010 08:04:49.988' prior: 0!
Customizable model index that may use any selector of a model that is appropriate to get #hasChildren, #text, or #icon.!

!UiPluggableModelIndex methodsFor: 'accessing - data' stamp: 'mt 10/16/2010 08:03:47.754'!
hasChildren

	^ model perform: hasChildrenSelector with: self! !

!UiPluggableModelIndex methodsFor: 'accessing' stamp: 'mt 10/16/2010 08:04:12.752'!
hasChildrenSelector

	^ hasChildrenSelector! !

!UiPluggableModelIndex methodsFor: 'accessing' stamp: 'mt 10/16/2010 08:04:04.084'!
hasChildrenSelector: aSymbol

	hasChildrenSelector := aSymbol.! !

UiModelIndex subclass: #UiSimpleModelIndex
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiSimpleModelIndex commentStamp: 'mt 10/16/2010 08:05:34.628' prior: 0!
Simple implementation of a model index that assumes that the model understands some default messages as #textFor:, #iconFor:, and #hasChildrenFor:.!
