
!UiViewSingleSelection methodsFor: 'as yet unclassified' stamp: 'mt 10/11/2010 09:21:51.677'!
add: aCellIndex event: aUserInputEvent

	selectedCell := aCellIndex.
	self selectionChanged.! !

!UiViewSingleSelection methodsFor: 'as yet unclassified' stamp: 'mt 10/11/2010 14:35:26.499'!
cells

	^ selectedCell
		ifNil: [#()]
		ifNotNil: [{selectedCell}]! !

!UiViewSingleSelection methodsFor: 'as yet unclassified' stamp: 'mt 10/11/2010 17:57:25.989'!
clear

	selectedCell := nil.
	self selectionChanged.! !

Morph subclass: #UiItemViewport
	instanceVariableNames: 'rows columns currentCell hoveredCell selectionColor selection selectionMode selectionBehavior verticalHeader horizontalHeader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiItemViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/11/2010 17:54:55.353'!
cellBoundsFor: aCellIndex

	| col row |
	(aCellIndex x > columns size
		or: [aCellIndex y > rows size])
		ifTrue: [^ 0@0 extent: 0@0].
	
	col := columns at: aCellIndex x.
	row := rows at: aCellIndex y.
	
	^ (self leftForColumn: col) @ (self topForRow: row)
		extent: col width @ row height! !

!UiItemViewport methodsFor: 'rows/columns - to cell' stamp: 'mt 10/9/2010 12:16:36.293'!
cellIndexFor: aModelIndex

	| rowIndex col |
	col := self columnFor: aModelIndex.
	rowIndex := col itemIndexFor: aModelIndex.

	^ aModelIndex column @ rowIndex! !

!UiItemViewport methodsFor: 'rows/columns - to cell' stamp: 'mt 10/9/2010 12:58:33.455'!
cellIndexFromPoint: aPoint
	"Given a point in pixel coordinates."
	
	| offset |
	offset := self topLeft.
	columns withIndexDo: [:colInfo :colIndex |
		rows withIndexDo: [:rowInfo :rowIndex | 
			((offset extent: colInfo width @ rowInfo height) containsPoint: aPoint)
				ifTrue: [^ colIndex @ rowIndex].
			offset := offset translateBy: 0 @ rowInfo height].
		offset := (offset x + colInfo width) @ self top].
	
	^ nil! !

!UiItemViewport methodsFor: 'initialization' stamp: 'mt 10/11/2010 17:56:54.347'!
clear

	self currentCell: nil.
	self selection clear.
	
	columns do: [:colInfo | colInfo clear].
	rows removeAll.
	self removeAllMorphs.! !

!UiItemViewport methodsFor: 'rows/columns - to info' stamp: 'mt 10/14/2010 19:27:25.658'!
columnAt: index

	index > columns size
		ifTrue: [index - columns size timesRepeat: [columns add: UiViewColumnInfo new]].
	
	^ columns at: index! !

!UiItemViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/11/2010 17:58:53.347'!
columnBoundsFor: aColIndex

	| col |
	aColIndex > columns size
		ifTrue: [^ 0@0 extent: 0@0].
		
	col := columns at: aColIndex.
	
	^ (self leftForColumn: col) @ self top
		extent: col width @ self height! !

!UiItemViewport methodsFor: 'iterating' stamp: 'mt 10/14/2010 10:25:48.766'!
columnsDo: aBlock

	columns do: aBlock.! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/11/2010 14:08:10.466'!
currentCell

	^ currentCell! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/11/2010 17:24:32.458'!
currentCell: aPoint

	aPoint = currentCell
		ifTrue: [^ self].
		
	currentCell := aPoint.
	self redrawLater.
	
	currentCell ifNotNil: [
		self focusChanged: (self cellBoundsFor: currentCell)].! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 10/11/2010 14:27:00.022'!
drawCurrentCellOn: aCanvas

	self currentCell ifNil: [^ self].
	
	self selectionBehavior = #selectCells ifTrue: [
		self
			drawHighlightOn: aCanvas
			bounds: (self cellBoundsFor: self currentCell)
			color: self selectionColor darker.
		^ self].
		
	self selectionBehavior = #selectRows ifTrue: [
		self
			drawHighlightOn: aCanvas
			bounds: (self rowBoundsFor: self currentCell y)
			color: self selectionColor darker.
		^ self].
	
	self selectionBehavior = #selectColumns ifTrue: [
		self
			drawHighlightOn: aCanvas
			bounds: (self columnBoundsFor: self currentCell x)
			color: self selectionColor darker.
		^ self]! !

!UiItemViewport methodsFor: 'drawing' stamp: 'mt 10/11/2010 16:14:39.006'!
drawSubmorphsOn: aCanvas 
	"Clip in cells. Optimized."
	
	| offset |
	submorphs isEmpty ifTrue: [^self].
	
	offset := self topLeft.
	columns withIndexDo: [:colInfo :colIndex |
		
		colInfo items withIndexDo: [:item :rowIndex | | rowInfo |
			rowInfo := rows at: rowIndex.
			aCanvas
				clipBy: (offset extent: colInfo width @ rowInfo height)
				during: [:canvas | canvas fullDrawMorph: item].
			
			offset := offset translateBy: 0 @ rowInfo height].
		
		offset := (offset x + colInfo width) @ self top].! !

!UiItemViewport methodsFor: 'accessing' stamp: 'mt 10/14/2010 13:14:56.09'!
indent

	^ 0! !

!UiItemViewport methodsFor: 'initialization' stamp: 'mt 10/11/2010 09:04:54.243'!
initialize

	super initialize.
	self color: Color transparent.
		
	rows := OrderedCollection new.
	columns := OrderedCollection new.
	
	self selectionMode: UiViewSingleSelection.! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 10/11/2010 18:00:37.316'!
keyStroke: evt

	"Manuall navigation."
	self currentCell ifNil: [^ self currentCell: 1@1].

	evt keyCharacter = Character arrowUp
		ifTrue: [self currentCell: (self currentCell - (0@1) max: 1@1)].
		
	evt keyCharacter = Character arrowDown
		ifTrue: [self currentCell: (self currentCell + (0@1) min: (columns size @ rows size) max: 1@1)].
		
	evt keyCharacter = Character arrowLeft
		ifTrue: [self currentCell: (self currentCell - (1@0) max: 1@1)].
		
	evt keyCharacter = Character arrowRight
		ifTrue: [self currentCell: (self currentCell + (1@0) min: (columns size @ rows size) max: 1@1)].
		
	self selection
		add: self currentCell
		event: evt.! !

!UiItemViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/9/2010 13:12:00.791'!
leftForColumn: aColumnInfo

	| result |
	result := self left.
	columns do: [:col |
		col = aColumnInfo ifTrue: [^ result].
		result := result + col width].
	
	Error signal: 'Column info not found!!'.! !

!UiItemViewport methodsFor: 'rows/columns - to model index' stamp: 'mt 10/9/2010 17:25:18.053'!
modelIndexFor: aCellIndex

	aCellIndex ifNil: [^ nil].
	
	^ ((columns at: aCellIndex x) items at: aCellIndex y)
		valueOfProperty: #modelIndex! !

!UiItemViewport methodsFor: 'event handling' stamp: 'mt 10/11/2010 17:05:42.001'!
mouseDown: evt

	self currentCell: (self cellIndexFromPoint: evt position).
	self selection
		add: self currentCell
		event: evt.
		
	evt hand
		waitForClicksOrDrag: self
		event: evt
		selectors: {#click:. #doubleClick:. nil. #startDrag:}
		threshold: 1. ! !

!UiItemViewport methodsFor: 'rows/columns - to info' stamp: 'mt 10/10/2010 15:08:43.412'!
rowAt: index

	^ rows at: index! !

!UiItemViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/11/2010 17:58:29.235'!
rowBoundsFor: aRowIndex

	| row |
	aRowIndex > rows size
		ifTrue: [^ 0@0 extent: 0@0].
		
	row := rows at: aRowIndex.
	
	^ self left @ (self topForRow: row)
		extent: self width @ row height! !

!UiItemViewport methodsFor: 'iterating' stamp: 'mt 10/14/2010 10:25:55.249'!
rowsDo: aBlock

	rows do: aBlock.! !

!UiItemViewport methodsFor: 'selection' stamp: 'mt 10/11/2010 09:12:39.162'!
selection: aSelection

	selection := aSelection.
	self connect: aSelection signal: #selectionChanged toSelector: #redrawLater.
	
	self redrawLater.! !

!UiItemViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/9/2010 13:11:55.553'!
topForRow: aRowInfo

	| result |
	result := self top.
	rows do: [:row |
		row = aRowInfo ifTrue: [^ result].
		result := result + row height].
	
	Error signal: 'Row info not found!!'.! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/14/2010 19:13:50.564'!
updateColumnsLayout

	| offset |
	columns withIndexDo: [:colInfo :colIndex |
		offset := 0.
		colInfo items withIndexDo: [:item :rowIndex |
			| height |
			height := (rows at: rowIndex) height.
			colInfo vAlignment = #top
				ifTrue: [item top: offset].
			colInfo vAlignment = #center
				ifTrue: [item top: offset + (height - item height // 2)].
			colInfo vAlignment = #bottom
				ifTrue: [item bottom: offset + height].
							
			offset := offset + height]].! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/14/2010 19:23:37.085'!
updateLayout

	columns ifEmpty: [^ self].
	
	columns do: [:column | column updateSize].
	rows do: [:row | row updateSize].
	
	self updateColumnsLayout.
	self updateRowsLayout.
	
	columns first items do: [:item |
		item left: self left + (item valueOfProperty: #indent)].

	"Relayout changed header items."
	self horizontalHeader ifNotNil: [:hh |
		hh removeAllMorphs.
		columns do: [:colInfo | hh addMorphBack: colInfo headerItem]].
	self verticalHeader ifNotNil: [:vh |
		vh removeAllMorphs.
		rows do: [:rowInfo | vh addMorphBack: rowInfo headerItem]].
	
	"Shrink wrap to contents."
	self updateExtent.! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/14/2010 19:13:41.424'!
updateRowsLayout

	| offset |
	self rowsDo: [:rowInfo |
		offset := 0.
		rowInfo items withIndexDo: [:item :colIndex |
			| width hAlignment |
			width := (columns at: colIndex) width.
			hAlignment := (columns at: colIndex) hAlignment.
			hAlignment = #left
				ifTrue: [item left: offset].
			hAlignment = #center
				ifTrue: [item left: offset + (width - item width // 2)].
			hAlignment = #right
				ifTrue: [item right: offset + width].
			
			offset := offset + width]].! !

!UiViewSelection methodsFor: 'as yet unclassified' stamp: 'mt 10/11/2010 08:57:38.881'!
add: aCellIndex! !

!UiViewSelection methodsFor: 'as yet unclassified' stamp: 'mt 10/11/2010 09:07:25.205'!
add: aCellIndex event: aUserInputEvent! !

!UiViewSelection methodsFor: 'as yet unclassified' stamp: 'mt 10/11/2010 08:56:27.565'!
addRangeFrom: topLeftCell to: bottomRightCell! !

!UiViewSelection methodsFor: 'as yet unclassified' stamp: 'mt 10/11/2010 08:57:25.839'!
addRangeTo: targetCell! !

!UiViewSelection methodsFor: 'as yet unclassified' stamp: 'mt 10/11/2010 09:13:15.101'!
cells
	"Return an array with all selected cells."
	
	self subclassResponsibility.! !

!UiViewSelection methodsFor: 'as yet unclassified' stamp: 'mt 10/11/2010 17:57:02.818'!
clear
! !

!UiIconPickerDialog methodsFor: 'as yet unclassified' stamp: 'mt 10/14/2010 21:04:17.021'!
initialize

	super initialize.
	
	iconSetCombo := UiComboBox new hResizing: #spaceFill.
	UiIcons subclassesDo: [:s | iconSetCombo addText: s name].
	self connect: iconSetCombo signal: #currentIndexChanged:text: toSelector: #changeIconSet:.
	
	iconView := UiListIconView new
		listOrientation: #vertical;
		model: (UiIconModel new showText: false);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderStyle: (BorderStyle inset width: 1).
	self connect: iconView signal: #clicked: toSelector: #chooseIcon:.
	
	self
		color: (Color gray: 0.9);
		changeTableLayout;
		listDirection: #topToBottom;
		layoutInset: 5;
		cellInset: 5;
		cellPositioning: #topLeft.
		
	self
		addMorphBack: (UiLabel new text: 'Select an icon set then pick an icon below. The code to get
the form will be copied into the <b>clipboard</b>.' asHtmlText);
		addMorphBack: iconSetCombo;
		addMorphBack: iconView.
		
	"Initial set."
	self changeIconSet: iconSetCombo currentIndex.! !

!UiTreeViewport methodsFor: 'event handling' stamp: 'mt 10/14/2010 13:17:52.299'!
click: evt

	| cell row item |
	cell := self cellIndexFromPoint: evt position.
	cell ifNil: [^ self].
	
	row := rows at: cell y.
	item := row items first.
	
	"Recognize a click on the decoration."
	(evt position x < item left
		and: [evt position x >= (item left - self indent)])
		ifTrue: [self decorationClicked: (item valueOfProperty: #modelIndex)].! !

!UiTreeViewport methodsFor: 'drawing' stamp: 'mt 10/14/2010 13:16:36.739'!
drawTreeStructureOn: aCanvas
	
	| first last |
	columns ifEmpty: [^ self].
	
	columns first width < aCanvas clipRect left
		ifTrue: [^ self].
	
	first := self cellIndexFromPoint: (self bounds pointNearestTo: aCanvas clipRect topLeft).
	last := self cellIndexFromPoint: (self bounds pointNearestTo: aCanvas clipRect bottomLeft).

	first ifNil: [first := 1@1].
	last ifNil: [last := 1@rows size].
	
	last < first ifTrue: [^ self].

	first y to: last y do: [:rowIndex |
		| item cellBounds form |
		cellBounds := self cellBoundsFor: 1@rowIndex.
		item := (rows at: rowIndex) items first.
		form := UiSilkIcons bulletArrowDownIcon.
		form := (item valueOfProperty: #hasChildren)
			ifFalse: [nil]
			ifTrue: [(item valueOfProperty: #isExpanded)
				ifFalse: [form rotateBy: #left centerAt: 8@8]
				ifTrue: [form]].

		form ifNotNil: [
			aCanvas
				translucentImage: form
				at: (cellBounds left + ((item valueOfProperty: #indent) - self indent))
					@ (cellBounds top + (cellBounds height - form height // 2))]].! !

!UiTreeViewport methodsFor: 'initialization' stamp: 'mt 10/14/2010 14:06:24.263'!
initialize

	super initialize.
	self selectionBehavior: #selectRows.! !

!UiListIconViewport methodsFor: 'rows/columns - to cell' stamp: 'mt 10/14/2010 17:18:49.01'!
cellIndexFromPoint: aPoint
	"Given a point in pixel coordinates."
	
	| cell |
	self orientation = #default ifTrue: [
		| offset |
		offset := self topLeft.
		rows withIndexDo: [:rowInfo :rowIndex | 
			((offset extent: self width @ rowInfo height) containsPoint: aPoint)
				ifTrue: [^ 1 @ rowIndex].
			offset := offset translateBy: 0 @ rowInfo height].
	
		^ nil].
	
	cell := ((aPoint - self topLeft) // (maxItemExtent)) + (1@1).
	
	self orientation = #vertical
		ifTrue: [
			(cell x > self maxItemsPerLine
				or: [cell y - 1 * self maxItemsPerLine + cell x > rows size])
				ifTrue: [^ nil]]
		ifFalse: [
			(cell y > self maxItemsPerLine
				or: [cell x - 1 * self maxItemsPerLine + cell y > rows size])
				ifTrue: [^ nil]].
	
	^ cell! !

!UiListIconViewport methodsFor: 'rows/columns - to model index' stamp: 'mt 10/14/2010 20:48:40.117'!
modelIndexFor: aCellIndex

	self orientation = #default
		ifTrue: [^ super modelIndexFor: aCellIndex].

	aCellIndex ifNil: [^ nil].
	
	^ (self orientation = #vertical
		ifTrue: [rows at: aCellIndex y - 1 * self maxItemsPerLine + aCellIndex x]
		ifFalse: [rows at: aCellIndex x - 1 * self maxItemsPerLine + aCellIndex y]) firstModelIndex! !

!UiListIconViewport methodsFor: 'layouting' stamp: 'mt 10/14/2010 19:20:50.681'!
updateLayout

	| offset hAlignment |
	self orientation = #default
		ifTrue: [^ super updateLayout].	
	
	columns ifEmpty: [^ self].
	
	maxItemExtent := 1@1.
	columns first items do: [:item | maxItemExtent := maxItemExtent max: item extent].

	offset := self topLeft.
	hAlignment := columns first hAlignment.
	self rowsDo: [:rowInfo | | item |
		item := rowInfo items first.
		
		hAlignment = #left
			ifTrue: [item topLeft: offset].
		hAlignment = #center
			ifTrue: [item topLeft: offset + ((maxItemExtent x - item width)//2 @0)].
		hAlignment = #right
			ifTrue: [item topRight: offset + (maxItemExtent x @ 0)].

		self orientation = #vertical
			ifTrue: [
				offset := offset + (maxItemExtent x @ 0).
				(offset x + maxItemExtent x)  > (self owner width - 5)
					ifTrue: [offset := self left @ (offset y + maxItemExtent y)]]
			ifFalse: [
				offset := offset + (0 @ maxItemExtent y).
				(offset y + maxItemExtent y)  > (self owner height - 5)
					ifTrue: [offset := (offset x + maxItemExtent x) @ self top]]].
		
	self updateExtent.		! !

Point subclass: #UiModelIndex
	instanceVariableNames: 'parent model properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiModelIndex commentStamp: 'mt 10/7/2010 17:34:22.768' prior: 0!
Short life expectancy.!

UiModelIndex subclass: #UiPluggableModelIndex
	instanceVariableNames: 'textSelector iconSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

UiModelIndex subclass: #UiSimpleModelIndex
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiSimpleModelIndex commentStamp: 'mt 10/7/2010 17:32:47.218' prior: 0!
Needs a model that implements the basic data functions in the following way:

#textFor:
#iconFor:
...!
